//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 C'0,70,0'
#property indicator_color2 C'70,0,0'
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_width1 45
#property indicator_width2 5
#property indicator_width3 2
#property indicator_width4 2
#property indicator_color5 Navy
#property indicator_color6 C'70,0,0'
#property indicator_color7 Yellow
#property indicator_color8 Blue
#property indicator_width5 45
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2

//
//
//
//
//

extern int    per=120;
extern int    price=PRICE_CLOSE;
extern double dev=2;
extern int    mamode;



//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer2);
   SetIndexBuffer(4,buffer7); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,buffer8); SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexBuffer(6,buffer5);
   SetIndexBuffer(7,buffer6);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double ma = iMA(NULL,0,per,0,mamode,price,i);
      double de = iStdDev(NULL,0,per,0,MODE_SMA,price,i);
      buffer1[i] = ma+de*dev;
      buffer2[i] = ma;
      buffer3[i] = buffer1[i];
      buffer4[i] = buffer2[i];
      buffer5[i] = ma;
      buffer6[i] = ma-de*dev;
      buffer7[i] = buffer5[i];
      buffer8[i] = buffer6[i];
   }
   return(0);
}

